//
//  HomeProtocols.swift
//  UpaxMovie
//
//  Created Imo on 29/02/24.
//  Copyright © 2024 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by UPAX Zeus
//

import Foundation

//MARK: Presenter -> Router
protocol HomeWireframeProtocol: AnyObject {
    func goDetail(_ item: Movie)
    func showDialog(_ item: Movie)
}

//MARK: View -> Presenter
protocol HomePresenterProtocol: AnyObject {
    var interactor: HomeInteractorInputProtocol? { get set }
    
    func movieList(_ page: Int, completion: @escaping (MovieResponse?) -> Void )
    func goDetail( _ item: Movie )
    func showDialog(_ item: Movie)
}

//MARK: Interactor -> Presenter
protocol HomeInteractorOutputProtocol: AnyObject {
    
}

//MARK: Presenter -> Interactor
protocol HomeInteractorInputProtocol: AnyObject {
    var presenter: HomeInteractorOutputProtocol?  { get set }
    func movieList(_ page: Int, completion: @escaping (MovieResponse?) -> Void )
}

//MARK: Presenter -> View
protocol HomeViewProtocol: AnyObject {
    var presenter: HomePresenterProtocol?  { get set }
}
